MainProgram:
  gosub Init
  while True
    if AlarmOn
      gosub CheckDoors
      gosub CheckOutside
      gosub CheckWindows
      gosub ResetOutputs
    endif
    gosub UpdateScreen
  wend 
end

CheckPort:
  //InPort 2000,SensorData
return

CheckOutside:
  gosub CheckPort
  if (SensorData bAND 0%100)   // check Zone 3
    if AlarmOn
      //OutPort 2001,3  // turn on radio and lamp
      RadioOn = True
      LampOn = True
      StartTime = Timer()
    endif
  endif
return

CheckWindows:   
  gosub CheckPort    
  if (SensorData bAND 0%10)   // check Zone 2
     //OutPort 2001,5        // turn on siren and lights
     SirenOn = True
     LampOn = True
     StartTime = Timer()
  endif
return

CheckDoors:
  gosub CheckPort
  if (SensorData bAND 1) = 0   // check Zone 1 for a low input
     // wait 15 seconds or until the mouse is pressed
     WAIT = 15
     gosub Wait
     if AlarmOn
       //OutPort 2001,5  // turn on siren and lights
       SirenOn = True
       LampOn = True
       gosub UpdateScreen
       StartTime = Timer()
     endif
  endif
return

Wait:
  // waits WAIT seconds and counts down
  WAIT=15
  temp1=WAIT
  // but will handle intrusion through window
  WaitTime = Timer()
  repeat
    temp2=Timer()
    repeat
    until Timer()>temp2+1000   
    gosub CheckWindows
    gosub UpdateScreen
    xyText 600,175,"    ","Times New Roman",25,fs_Bold
    xyText 600,175,temp1,"Times New Roman",25,fs_Bold
    temp1 = temp1-1
  until (Timer() > (WaitTime)+(WAIT*1000)) or not AlarmOn
  xyText 600,175,"    ","Times New Roman",25,fs_Bold
return 

ResetOutputs:
  if StartTime <> 0
    if Timer() > (StartTime+(1000*MaxON))
      //OutPort 2001,0 // turn off all lights, radio and siren
      MaxTime = 0  // reset time
      LampOn = False
      RadioOn = False
      SirenOn = False
    endif
  endif
return   
      
Init:
  OnKey kHandler
  OnMouse mHandler
  Code = "   " // three spaces
  MyCode = "123"
  SensorData = 1
  StartTime = 0  // Starting time for
  MaxON = 10 // Outputs ON max 10 seconds
  AlarmOn = False
  RadioOn = False
  LampOn = False
  SirenOn = False
  LineWidth 3
  Rectangle 80,50,720,550
  LineWidth 2
  Line 80,420,720,420
  Line 80,250,720,250,3
  xyText 90,75,"Customizable Security System","Times New Roman",36,fs_Bold
  Line 80,140,720,140,3
  xyText 300,175,"Alarm is ","Times New Roman",25,fs_Bold
  xyText 300,210," Enter code to change "
  xyText 300,225,"(Simulation Code = 123)"

  xyText 150,280,"Zone 1           Zone 2           Zone 3","Arial",24
  xyText 165,320,"(doors)              (windows)              (outside)"
  xyText 150,450," Lights             Radio             Siren","Arial",24
  LineWidth 2
  Line 300,250,300,550
  Line 500,250,500,550
  xyText 80,570,"For simulation CLICK Zones (Left-Click for THREAT, Rt-Click for SECURE)."
  gosub UpdateScreen
return

UpdateScreen:
  gosub CheckPort
  if AlarmOn
    SetColor Red
    xyText 430,175," ON ","Times New Roman",25,fs_Bold
  else
    SetColor Green
    xyText 430,175,"OFF","Times New Roman",25,fs_Bold
  endif
  if (SensorData bAND 1) = 0
    SetColor Red
    xyText 150,350,"THREAT ","Ariel",18,fs_Bold
  endif
  if SensorData bAND 1
    SetColor Green
    xyText 150,350,"SECURE ","Ariel",18,fs_Bold
  endif
  if SensorData bAND 2
    SetColor Red
    xyText 350,350,"THREAT ","Ariel",18,fs_Bold
  endif
  if (SensorData bAND 2) = 0
    SetColor Green
    xyText 350,350,"SECURE ","Ariel",18,fs_Bold
  endif
  if SensorData bAND 4
    SetColor Red
    xyText 550,350,"THREAT ","Ariel",18,fs_Bold
  endif
  if (SensorData bAND 4) = 0
    SetColor Green
    xyText 550,350,"SECURE ","Ariel",18,fs_Bold
  endif  
  if LampOn
    SetColor Red
    xyText 170,500," ON ","Ariel",18,fs_Bold
  else
    SetColor Green
    xyText 170,500,"OFF","Ariel",18,fs_Bold
  endif
  if RadioOn
    SetColor Red
    xyText 370,500," ON ","Ariel",18,fs_Bold
  else
    SetColor Green
    xyText 370,500,"OFF","Ariel",18,fs_Bold
  endif  
  if SirenOn
    SetColor Red
    xyText 570,500," ON ","Ariel",18,fs_Bold
  else
    SetColor Green
    xyText 570,500,"OFF","Ariel",18,fs_Bold
  endif      
  SetColor Black
return

kHandler:
   n = LastKey()
   n = char(n) // convert ascii code to a character
   //if Length(n) <> 1 then n=" "
   Code = Right(Code,2)+n
   if Code=MyCode
      if AlarmOn
        //OutPort 2001,0 // turn off all lights, radio and siren
        AlarmOn=False
        RadioOn = False
        LampOn = False
        SirenOn = False
      else
        AlarmOn=True
      endif
   endif
   OnKey kHandler
return

mHandler:
   n = LastMouse()
   ReadMouse x,y,b  
   if WithIn(y,250,420)
     if n=1
        if Within(x,80,299)  then SensorData = SensorData bAND 0%11111110 // door open
        if Within(x,301,499) then SensorData = SensorData bOR  0%00000010 // window open
        if Within(x,501,720) then SensorData = SensorData bOR  0%00000100 // outside triggered
     endif
     if n=2
        if Within(x,80,299)  then SensorData = SensorData bOR  0%00000001 // door closed
        if Within(x,301,499) then SensorData = SensorData bAND 0%11111101 // window closed
        if Within(x,501,720) then SensorData = SensorData bAND 0%11111011 // outside safe
     endif
   endif
   OnMouse mHandler
return
